//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
#include <math.h> //    
#define max(a, b)  (((a) > (b)) ? (a) : (b))
int cx,cy; //  

float dist (int x1, int y1, int x2, int y2) { //    
 return sqrt(pow(x1-x2,2)+pow(y1-y2,2));
}

void __fastcall TForm1::FormClick(TObject *Sender) { // OnClick 
 float scale=sqrt(pow(Form1->ClientWidth,2)+pow(Form1->ClientHeight,2));
  //   =   
 unsigned int r,z;
 for (int x=0; x<Form1->ClientWidth; x++)
 for (int y=0; y<Form1->ClientHeight; y++) {
  r=dist (x,y,cx,cy); //      
  z=r*255./scale; //   
  Form1->Canvas->Pixels[x][y]=(TColor)RGB(z,z,z); // 
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender) {
 // OnCreate  -      
  cx = Form1->ClientWidth/2;
  cy = Form1->ClientHeight/2;
  Form1->DoubleBuffered=true; //   . 
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y) {
 // OnMouseDown  -  
 cx=X; cy=Y;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender) {
 // OnPaint  -   
 this->FormClick(Form1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender) {
 // OnResize  - ,   
 Form1->Invalidate();
}
//---------------------------------------------------------------------------

